package ${package};
import costo.kml2java.framework.*;
import costo.kml2java.framework.test.*;
import costo.kml2java.framework.kmllibs.*;
import costo.kml2java.framework.channels.*;
import static costo.kml2java.framework.kmllibs.KmeliaDefaultLib.*;

<#if generatesimplevue>
import jungtest.out.SimpleTest;
</#if>
 
<#list imports?if_exists as import>
import ${import};
</#list>
/**
 *
 * @author costo kml2Java Generator
 * this code requires costo.kml2java.jar
 * <#if generatesimplevue>
 *  and costo.kml2java.visu.jar
 * </#if>
 */
public class ${name} extends ExecutableComponent {


public ${name}(String name, ExecutionContext owner, String id){
super(name, owner, id);
}


public ${name}(String name, ExecutionContext owner){
super(name, owner);
}

public ${name}(){
super();
}

// Component state
<#list fields?if_exists as field>
${field.type} ${field.name} <#if field.needsconstruction?if_exists>= new ${field.type}()</#if> <#if field.array?if_exists >= new ${field.value}</#if>  ; ;
public ${field.type} ${field.gettername}(){ return this.${field.name};}
</#list>



// constants
<#list constants?if_exists as field>
${field.modifiers} ${field.type} ${field.name} <#if field.isconst> = ${field.value} </#if>;
public ${field.type} ${field.gettername}(){ return this.${field.name};}
</#list>


// delegatesandcalculatedvar
<#list delegatesandcalculatedvar?if_exists as field>
public ${field.type} ${field.gettername}(){ return ${field.value};}
</#list>


// SUB Components
<#list subcomponents?if_exists as field>
${field.type} ${field.name}  ;
public ${field.type} ${field.gettername}(){ return this.${field.name};}
public void set${field.name}(${field.type} comp){ this.${field.name}=comp;}
</#list>

// Promoted variables
<#list promotedgetters?if_exists as getter>
public ${getter.type} ${getter.gettername}(){
return ${getter.value};
}
</#list>
// method for invariant


@Override
public void createServices(){
this.name="${name}";
<#list services?if_exists as service>
${service.name} a${service.name} = new ${service.name}();
a${service.name}.setOwner(this);
a${service.name}.setName("${service.servicename}");
<#if service.ispromoted>
a${service.name}.setOrigCompName("${service.origcompname}");
a${service.name}.setOrigServName("${service.origservname}");
</#if>
this.${service.type}services.put("${service.servicename}", a${service.name});
//a${service.name}.init();
</#list>
//initServices();
}

@Override
public void resolvePromotedServices(){
// TODO : forall promoted, set their origin ...
// du genre prompted.setOrigin(c1.getService("machin")
}

@Override
public void initState(){
this.autorun="${autorun}";
<#list initfields?if_exists as init>
${init};
</#list>
}

@Override
public void initSubComponents(){

// Init subcomponents
<#list subcomponents?if_exists as field>
${field.name} = new ${field.type}("${field.type}", innerContext,"${field.name}");
this.innerContext.addInstance("${field.name}",${field.name});



</#list>
<#if composite>
this.innerContext.setOwner(this);
</#if>

<#list subcompconfig?if_exists as config>
${config}

</#list>

}

@Override
public void initBindings(){
<#list bindings?if_exists as binding>
this.innerContext.addBinding( new AssemblyBinding("${binding.bname}",
innerContext, "${binding.cclientname}", "${binding.cservername}", "${binding.sclientname}", "${binding.sservername}"));
</#list>
<#list promotionbindings?if_exists as binding>
this.innerContext.addBinding( new RPromotionBinding("${binding.bname}",
innerContext, "${binding.cclientname}", "${binding.cservername}", "${binding.sclientname}", "${binding.sservername}"));
</#list>  
}
<#list methods?if_exists as method>
//${method.comment?if_exists}
${method.modifiers} ${method.returntype} ${method.signature}{
${method.body};
}
</#list>

@Override
public boolean equals(Object o){
if (!(o instanceof ${name})) return false;
${name} other=(${name})o;
<#list fields?if_exists as field>
if (!other.${field.name}.equals(this.${field.name})) return false;
</#list>
return true;
}


@Override
public String toString(){
StringBuffer result=new StringBuffer("${name}: [");
<#list fields?if_exists as field>
result.append("${field.name}");
result.append(":");
result.append(${field.name});
<#if field_has_next>result.append(", ");</#if>
</#list>
result.append("]");
return result.toString();
}

<#if appli>
 
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		${name} comp = new ${name}("run",null);
	
		comp.addServiceListener(new ServiceEvolutionValidator());
		comp.init();
		
	}
 </#if>

}