package ${package};

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.List;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.input.SAXBuilder;
<#list imports?if_exists as import>
import ${import};
</#list>

public class ${name}{
	public static void main(String [] args){
		Element allElements = null;
		
		try {
			
			BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(new File(${xml_path}))));			 
			String line = "";
	        StringBuilder builder = new StringBuilder();
	        
	        while((line = in.readLine()) != null){
	        	builder.append(line);
	        }
	        String content = builder.toString();
	        
	        if(content.length()>0){
	        	
		        ByteArrayInputStream stream = new ByteArrayInputStream(content.getBytes());
		        SAXBuilder sxb = new SAXBuilder();
		        Document xmlDoc = sxb.build(stream);
		        allElements = xmlDoc.getRootElement();		        
		        List<Element> tcases = allElements.getChildren("testcase");			        
		        Iterator<Element> l = tcases.iterator();

		        while(l.hasNext()){
		        	Element ccase = (Element)l.next();
		        	${package_lib}.${class_lib}.currentNode = ccase;
		        	
		        	${component_class_name} comp = new ${component_class_name}("run",null);
					comp.addServiceListener(new ServiceEvolutionValidator());
					comp.init();
		        }
	        }
	        
		} catch (Exception e) {
			e.printStackTrace();
		}

	}
}